
/*
zwwwwwwwwwwwwwwwwwwwwwwwwwwww{
x CBanner v2.6  rj{  (DOS )    Apr 1,1994 x
x                                                        x
x                                                        x
x Ѽƻ: CBanner  [-e] [-h] [-s xxx] [-cx] [-fx] [-1] x
x                                                        x
x            -e      For English Help                    x
x            -h      廲UT                        x
x            -s xxx  xxx Bzr                  x
x            -cx     x Hrզ@Ӧr            x
x            -fx     x=s,l ϥ16(small),24(large)r   x
x            -1      ϥβĤ@ئr˦ ( -2,-3 ..,-8 )  x
x                                                        x
x     Note:  1. Ѽ -cx ubϥ -3..-8  ĪG       x
x            2. DΫĳ w mail UCa}    x
x                                                        x
x                            Sheen Cherng-Dar - Ҧ~K x
|wwwwwwwwwwwwwwwwwwwwwwwwwwww}
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "csfont.h"
#include "orgpath.h"

#ifdef __MSDOS__
#include "chinese.h"
#endif

#define CFGFILE "cbanner.cfg"

void main(int argn,char *argv[])
{

  int i,err;
  char Combine='O';
  unsigned char Font='l';
  unsigned char FontType=1;
  char Fill,Id,String[80]="";
  CSFont ban;

  void EngHelp(void);
  void ChiHelp(void);
  void Error(void);

  for(i=1;i<argn;i++)
  {
     if(argv[i][0]=='-')
     {
       Id=argv[i][1];
       if(Id=='h')
       {
         #ifdef __MSDOS__
           if(CSExist())
             ChiHelp();
           else
             EngHelp();
         #else
             ChiHelp();
         #endif
       }
       else if(Id=='e')
       {
         #ifdef __MSDOS__
           if(CSExist())
             ChiHelp();
           else
             EngHelp();
         #else
             EngHelp();
         #endif
       }
       else if(Id=='p')
       {
         if(ban.PathConfig(strcat(OrgPath(argv[0]),CFGFILE)))
           printf("Can't not create configuration file correctly !\n");
         exit(0);
       }
       else if(Id=='c') Combine=argv[i][2];
       else if(Id=='f') Font=argv[i][2];
       else if(Id=='s') strcpy(String,argv[++i]);
       else if((Id<'9')&&(Id>'0')) FontType=Id-'0';
       else Error();
     }
     else
       Error();
  }

  if(err=ban.OpenFont24(strcat(OrgPath(argv[0]),CFGFILE)))
  {
    printf("Error in open 24x24 file !  Err Code: %d\n",err);
    printf("Please type 'cbanner -p' to install font file.\n");
    exit(3);
  }
  if(err=ban.OpenFont16(strcat(OrgPath(argv[0]),CFGFILE)))
  {
    printf("Error in open 16x15 file !  Err Code: %d\n",err);
    printf("Please type 'cbanner -p' to install font file.\n");
    exit(3);
  }


  if(!String[0])
  {
    printf("C-Banner v2.6     ( cbanner -h for detail )\n");
    printf("Input a string : ");
    gets(String);
    if(!String[0]) exit(1);
  }
  if(Font=='s')
    ban.Cbanner16(String,FontType,Combine);
  else
    ban.Cbanner24(String,FontType,Combine);

  ban.CloseFont24();
  ban.CloseFont16();
}

void ChiHelp(void)
{
  printf("zwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww{\n");
#ifdef __MSDOS__
  printf("x CBanner v2.6  rj{  (DOS )         Apr 1,1994    x\n");
#else
  printf("x CBanner v2.6  rj{  (UNIX )        Feb 1,1994    x\n");
#endif
  printf("x                                                                x\n");
  printf("x                                                                x\n");
  printf("x Ѽƻ: CBanner  [-e] [-h] [-p] [-s xxx] [-cx] [-fx] [-1]    x\n");
  printf("x                                                                x\n");
#ifndef __MSDOS__
  printf("x            -e          For English Help                        x\n");
  printf("x            -h          廲UT                            x\n");
#else
  printf("x            -h          UT                                x\n");
#endif
  printf("x            -p          w˦r                              x\n");
  printf("x            -s string   Bzr                            x\n");
  printf("x            -cx         H x rզ@Ӧr                   x\n");
  printf("x            -fx         ϥ16x15(x=s),24x24(x=l) r          x\n");
  printf("x            -1          ϥβĤ@ئr˦ ( -2,-3 ..,-8 )      x\n");
  printf("x                                                                x\n");
#ifndef __MSDOS__
  printf("x     Note:  1. ϥ -s Ѽ Щ .tcshrc [W@           x\n");
  printf("x               setenv LC_CTYPE iso_8859_1                       x\n");
  printf("x            2. Ѽ -cx ubϥ -3..-8  ĪG               x\n");
  printf("x            3. ݫOҩҦJtr                     x\n");
  printf("x               _hݫemH '\\' קK~P                        x\n");
//printf("x            4. DΫĳ w mail UCa}            x\n");
#else
  printf("x     Note:  1. Ѽ -cx ubϥ -3..-8  ĪG               x\n");
//printf("x            2. DΫĳ w mail UCa}            x\n");
#endif
  printf("x                                                                x\n");
  printf("x                                              Sheen Cherng-Dar  x\n");
  printf("|wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww}\n");
  exit(0);
}

void EngHelp(void)
{
  printf("ͻ\n");
#ifdef __MSDOS__
  printf("  CBanner v2.6 - Chinese Banner ( for DOS )          Apr 1,1994  \n");
#else
  printf("  CBanner v2.6 - Chinese Banner ( for UNIX )         Feb 1,1994  \n");
#endif
  printf("                                                                 \n");
  printf("                                                                 \n");
  printf("    Usage:  CBanner  [-e] [-h] [-p] [-s xxx] [-cx] [-fx] [-1]    \n");
  printf("                                                                 \n");
#ifndef __MSDOS__
  printf("             -e           For English Help                       \n");
  printf("             -h           For Chinese Help                       \n");
#else
  printf("             -h           For Help                               \n");
#endif
  printf("             -p           Install font file                      \n");
  printf("             -s string    the string to banner                   \n");
  printf("             -cx          x is the char to combine a word        \n");
  printf("             -fx          Use 16x15(x=s),24x24(x=l) font         \n");
  printf("             -1           Use No.1 Font type ( -2,-3 ..,-8 )     \n");
  printf("                                                                 \n");
#ifndef __MSDOS__
  printf("      Note:  1. To use -s option, please add a line in           \n");
  printf("                your .tcshrc [setenv LC_CTYPE iso_8859_1]        \n");
  printf("             2. option -cx is only avail. with -3..-8            \n");
  printf("             3. Be sure your input does not contain              \n");
  printf("                special char, else use '\\' before it.            \n");
//printf("             4. any suggestion, tell me ! Thanks.                \n");
#else
  printf("      Note:  1. option -cx is only avail. with -3..-8            \n");
//printf("             2. any suggestion, tell me ! Thanks.                \n");
#endif
  printf("                                                                 \n");
  printf("                                              Sheen Cherng-Dar   \n");
//#ifndef __MSDOS__
//printf("                               cdsheen@csie.nctu.edu.tw          \n");
//#endif
  printf("ͼ\n");
  exit(0);
}

void Error(void)
{
  printf("\n Invalid option ! Please type  cbanner -h  for help.\n");
  EngHelp();
}

