#include "svga.h"
#include "conio.h"

// This is a demo of
//
// c:\ > Magic -s oOMagic.exe -f test.cpp
//
// You can change 'init_svga_graph' to your Turbo Graphic Library,
// And use ShowFont?(X,Y,color,putpixel); to show font under graphic mode

void ShowFont1(int X,int Y,unsigned char color,void (*Function)(unsigned int,unsigned int,unsigned char));

void main(void)
{
  init_svga_graph(0x12);
  ShowFont1(100,100,13,putpixel);
  getch();
  closegraph();
}

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "o" */
 unsigned char Font0[]={
 0x0, 0x6, 0x0, 0x0, 0x3, 0x0, 0x40, 0x3, 0x80, 0x30, 0x1, 0x6,
 0x1B, 0xFF, 0xFF, 0x18, 0x0, 0x0, 0x0, 0x0, 0x18, 0xC, 0x7F, 0xFC,
 0xFE, 0x0, 0x0, 0xC, 0x0, 0x18, 0xC, 0x7F, 0xFC, 0x18, 0x0, 0x0,
 0x30, 0x0, 0x0, 0x7C, 0x40, 0x18, 0xC, 0x7F, 0xFC, 0xC, 0x60, 0x18,
 0xC, 0x60, 0x18, 0x18, 0x60, 0x18, 0x18, 0x7F, 0xF8, 0x30, 0x60, 0x10,
 0xFC, 0x40, 0x0, 0xC7, 0x80, 0x0, 0x1, 0xFF, 0xFF, 0x0, 0x7F, 0xFC };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "O" */
 unsigned char Font1[]={
 0x4, 0x0, 0x60, 0x7, 0xFF, 0xF0, 0x6, 0x0, 0x60, 0x6, 0x0, 0x60,
 0x6, 0x0, 0x60, 0x7, 0xFF, 0xE0, 0x6, 0x0, 0x60, 0x6, 0x0, 0x60,
 0x6, 0x0, 0x60, 0x7, 0xFF, 0xE0, 0x4, 0x0, 0x40, 0x0, 0x0, 0x6,
 0xFF, 0xFF, 0xFF, 0x0, 0x18, 0x0, 0x4, 0x18, 0x0, 0x7, 0x18, 0x30,
 0x6, 0x1F, 0xF8, 0x6, 0x18, 0x0, 0xC, 0x18, 0x0, 0xE, 0x18, 0x0,
 0x19, 0x98, 0x0, 0x30, 0xFF, 0xFF, 0x40, 0x3F, 0xFC, 0x80, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of " "  */
 unsigned char Font2[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "M"  */
 unsigned char Font3[]={
 0x0, 0x0, 0x0, 0x0, 0xE0, 0x70, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60,
 0x70, 0xE0, 0x70, 0xE0, 0x70, 0xE0, 0x70, 0xE0, 0x79, 0xE0, 0x69, 0x60,
 0x69, 0x60, 0x6F, 0x60, 0x66, 0x60, 0x66, 0x60, 0x66, 0x60, 0x60, 0x60,
 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0xF0, 0xF0, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "a"  */
 unsigned char Font4[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3F, 0x0, 0x61, 0x80, 0xF0, 0xC0,
 0x60, 0xC0, 0x0, 0xC0, 0xF, 0xC0, 0x38, 0xC0, 0x60, 0xC0, 0xC0, 0xC0,
 0xC0, 0xC0, 0xC0, 0xC0, 0xE3, 0xC0, 0x3E, 0x60, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "g"  */
 unsigned char Font5[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3E, 0x60, 0x63, 0xE0, 0xC1, 0x80,
 0xC1, 0x80, 0xC1, 0x80, 0x63, 0x0, 0x3E, 0x0, 0x60, 0x0, 0x78, 0x0,
 0xCF, 0x80, 0xC1, 0xC0, 0xC0, 0x60, 0xC0, 0x60, 0x60, 0xC0, 0x3F, 0x80 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "i"  */
 unsigned char Font6[]={
 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0xF, 0x0, 0xF, 0x0, 0x6, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1E, 0x0, 0x6, 0x0, 0x6, 0x0,
 0x6, 0x0, 0x6, 0x0, 0x6, 0x0, 0x6, 0x0, 0x6, 0x0, 0x6, 0x0,
 0x6, 0x0, 0x6, 0x0, 0x6, 0x0, 0x1F, 0x80, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "c"  */
 unsigned char Font7[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1F, 0x0, 0x31, 0xC0, 0x60, 0xE0,
 0x61, 0xE0, 0xC0, 0xC0, 0xC0, 0x0, 0xC0, 0x0, 0xC0, 0x0, 0xC0, 0x0,
 0x60, 0x0, 0x60, 0x60, 0x30, 0xC0, 0x1F, 0x80, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "."  */
 unsigned char Font8[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0xC, 0x0, 0x1E, 0x0, 0x1E, 0x0, 0xC, 0x0, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "e"  */
 unsigned char Font9[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1F, 0x0, 0x31, 0x80, 0x60, 0xC0,
 0x60, 0xC0, 0xC0, 0x60, 0xC0, 0x60, 0xFF, 0xE0, 0xC0, 0x0, 0xC0, 0x0,
 0x60, 0x0, 0x60, 0x60, 0x30, 0xC0, 0x1F, 0x80, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "x"  */
 unsigned char Font10[]={
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xF1, 0xE0, 0x60, 0xC0, 0x60, 0xC0,
 0x31, 0x80, 0x1B, 0x0, 0xE, 0x0, 0xE, 0x0, 0xE, 0x0, 0x1B, 0x0,
 0x31, 0x80, 0x60, 0xC0, 0x60, 0xC0, 0xF1, 0xE0, 0x0, 0x0, 0x0, 0x0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "e"  */
 unsigned char *Font11=Font9;

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of " "  */
 unsigned char *Font12=Font2;

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "" */
 unsigned char Font13[]={
 0x8, 0x2, 0x0, 0xE, 0x3, 0x80, 0xC, 0x3, 0x0, 0x18, 0x3, 0x0,
 0x50, 0xC6, 0x6, 0x7F, 0xE7, 0xFF, 0x60, 0xC6, 0x6, 0x60, 0xCC, 0x6,
 0x60, 0xC8, 0x6, 0x60, 0xD0, 0x6, 0x60, 0xC4, 0x6, 0x60, 0xC2, 0x6,
 0x7F, 0xC3, 0x6, 0x60, 0xC1, 0x86, 0x60, 0xC1, 0x86, 0x60, 0xC1, 0x86,
 0x60, 0xC0, 0x6, 0x60, 0xC0, 0x6, 0x60, 0xC0, 0x6, 0x60, 0xC0, 0xE,
 0x7F, 0xC0, 0xC, 0x60, 0x80, 0x1C, 0x40, 0x1, 0xF8, 0x0, 0x0, 0x30 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "" */
 unsigned char Font14[]={
 0x0, 0x38, 0x0, 0x20, 0xC, 0x6, 0x3F, 0xFF, 0xFF, 0x31, 0x99, 0x80,
 0x33, 0x30, 0xCC, 0x33, 0x3F, 0xFE, 0x36, 0x70, 0xC0, 0x37, 0x70, 0xC8,
 0x3B, 0xBF, 0xFC, 0x33, 0x30, 0xC0, 0x33, 0x30, 0xC8, 0x33, 0x3F, 0xFC,
 0x33, 0x30, 0xC0, 0x33, 0x30, 0xC6, 0x33, 0x3F, 0xFF, 0x32, 0x20, 0x0,
 0x30, 0x88, 0x0, 0x30, 0xE6, 0x8, 0x62, 0xC3, 0x4, 0x62, 0xC2, 0x26,
 0x46, 0xC0, 0x23, 0x4C, 0xC0, 0x33, 0x9C, 0xFF, 0xF0, 0x88, 0x7F, 0xE0 };

/* ------  Show Chinese without Chinese System   [S.C.D] ------ */
/* The font data of "" */
 unsigned char Font15[]={
 0x10, 0x0, 0xC, 0x1F, 0xFF, 0xFE, 0x18, 0x18, 0xC, 0x18, 0x18, 0xC,
 0x18, 0x18, 0xC, 0x18, 0x18, 0xC, 0x18, 0x18, 0xC, 0x1F, 0xFF, 0xFC,
 0x18, 0x18, 0xC, 0x18, 0x18, 0xC, 0x18, 0x18, 0xC, 0x18, 0x18, 0xC,
 0x18, 0x18, 0xC, 0x1F, 0xFF, 0xFC, 0x18, 0x18, 0xC, 0x18, 0x18, 0xC,
 0x18, 0x18, 0xC, 0x30, 0x18, 0xC, 0x30, 0x18, 0xC, 0x30, 0x18, 0xC,
 0x60, 0x18, 0xC, 0x60, 0x18, 0xC, 0x40, 0x11, 0xFC, 0x80, 0x0, 0x38 };

unsigned char *Ptr1[]={ Font0,Font1,Font2,Font3,Font4,Font5,Font6,Font7,Font8,Font9,Font10,Font11,Font12,Font13,Font14,Font15 };

unsigned char Mode1[]={ 3,3,2,2,2,2,2,2,2,2,2,2,2,3,3,3 };

/*-----------------------------------------------------------*/
/* ƱN|ù (X,Y) BøXr      */
/* [oO Magic.exe ] */
/*  Function øI Ҧp: putpixel        */
/*  It's just an example, develop it yourself */
void ShowFont1(int X,int Y,unsigned char color,void (*Function)(unsigned int,unsigned int,unsigned char))
{                                               
 unsigned char* buffer;                         
 for(int w=0;w<16;w++)                          
 {                                              
   buffer=Ptr1[w];                             
   for(int i=0;i<=23;i++)                       
     for(int j=0;j<Mode1[w];j++)               
       for(int k=0;k<8;k++)                     
         if( (buffer[i*Mode1[w]+j]>>k)&1 )     
           Function(X+j*8+(8-k),Y+i,color);     
   X+=Mode1[w]*12-12;                          
 }                                              
}                                               

/* It is in order to record current data, Don't remove it ! */
/* HUŸμƭȭpާ@T ФŲh HϱoUާ@αUh
[SCD]
16 16 1
[End of Record]  */
