/* ----------------------------------- */
/*  tΦrε{w    쪩     */
/*  Sheen Cherng-Dar      Apr 1,1994   */
/* ----------------------------------- */

/*************************************************************/
/*                                                           */
/*       CSFont::PathConfig()  rɦw˨禡                */
/*       CSFont::OpenFont24()  } 24x24 r             */
/*       CSFont::OpenFont16()  } 15x16 r             */
/*         CSFont::FontInfo()  Ū Big-5 XT             */
/*       CSFont::ReadFont24()  Ū@ 24x24 r           */
/*       CSFont::ReadFont16()  Ū@ 15x16 r           */
/*      CSFont::CloseFont24()   24x24 r             */
/*      CSFont::CloseFont16()   15x16 r             */
/*        CSFont::PutFont24()  øs(24x24)               */
/*        CSFont::PutFont16()  øs(15x16)               */
/*        CSFont::Cbanner24()  r ASCII j(24x24)      */
/*        CSFont::Cbanner16()  r ASCII j(15x16)      */
/*   CSFont::AutoShowFont24()  ۰ʨqr{X;(24x24)   */
/*                                                           */
/*************************************************************/

/**************************************************************/
/* Big-5 code range:                                          */
/*  High:81h-FEh(126) Low:40h-7Eh,A1h-FEh(157)  126*157=19782 */
/**************************************************************/
/*
zwwwwwwswwwwswwwwswwwwwswwswwww{
xstdfont.24? xзǦrx `Φr xA440-C67E x5401x        x
x(hanstd.24) x        x`ΦrxC940-F9D5 x7652x        x
x            x        x ʤѦr xF9D6-F9FE x  41x        x
uwwwwwwqwwwwqwwwwqwwwwwqwwqwwwwt
xspcfont.24  xSŸx зǦr xA140-A3BF x 408x        x
x(han-gr.24) x        x r xA3C0-A3E0 x  33x<- Od x
x            x        x iyr xA3E1-A3FE x  30x<- Od x
uwwwwwwqwwwwqwwwwqwwwwwqwwqwwwwt
xspcfsupp.24 xSrx        xC6A1-C8FE x 365x408 max.x
x(han-gr1.24)x        x        x          x*318xHan's 24x
uwwwwwwqwwwwqwwwwqwwwwwqwwqwwwwt
xascfont.24  x  ASCII x        x          x 256x        x
x(han-asc.24)x        x        x          x    x        x
|wwwwwwrwwwwrwwwwrwwwwwrwwrwwww}
*/

/* s̪: 1) {wDѳ\h̥e\hp{ gzӱo
                ]i঳\hƬOAҤݭn N⥦@ѦҤΧa
             2) {XiL󤾪, L۫HA@wON諸n
             3) ̤jDObܤjqr tפQC DiX
                brŪ Φrøs ѩϥΤ@Ӧr@ӦrŪ
                Τ@I@IeWh iϱo PutFont tץOALkԨ
             4)  library Ȥ䴩ʤ(>3.0) M_~(>3.2) tΪr

         *** 5) ϥΤk:
                a. [J #include "csfont.h"
              * b. tcc myfile.cpp clib.lib

             6)  Source code,  Turbo C++ 3.0 Uoi,
                ĳ TLIB @{w SjƧiAΦb UNIX U
             7) zQB qЧ , and report bugs to:
                 cdsheen@csie.nctu.edu.tw
*/

#ifndef __CS_Font__
#define __CS_Font__

#include <stdio.h>

/* Error Codes */
#define Success                0      // @ư榨\Ǧ^

/* PathConfig() Ǧ^ */
#define ErrorCreateCFG         1      // Lkإ߳]w
#define SystemNotSupport       2      // 䴩䥦t

/* OpenFont16 & OpenFont24 Ǧ^ */
#define ErrorOpenCFG           1      // Lk}ҳ]w

#define ErrorOpen16Asc         2      // Lk} ascfont.15 or han-asc.15
#define ErrorOpen16Std         3      // Lk} stdfont.15 or hanstd1.15
#define ErrorOpen16Spc         4      // Lk} spcfont.15 or han-gr.15
#define ErrorOpen16Spcf        5      // Lk} spcfsupp.15 or han-gr1.15
#define ErrorOpen16Std2        6      // Lk} hanstd2.15

#define ErrorOpen24Asc         2      // Lk} ascfont.24 or han-asc.24
#define ErrorOpen24Std         3      // Lk}ҳ]w 24x24 r
#define ErrorOpen24Spc         4      // Lk} spcfont.24 or han-gr.24
#define ErrorOpen24Spcf        5      // Lk} spcfsupp.24 or han-gr1.24


/* tκ */
#define Sys_Eten      'E'      // ʤѤt
#define Sys_Han       'H'      // _~t

/* 24x24 r */
#define Font_Ming     '1'      // r
#define Font_Kai      '2'      // Ѧr
#define Font_Li       '3'      // Ѧr
#define Font_Shing    '4'      // Ѧr
#define Font_Hei      '5'      // r
#define Font_Round    '6'      // r (ʤ)
#define Font_Fonsung  '6'      // 駺r (_~)
#define Font_Simple   '7'      // ²r (_~)

/* FontInfo Ǧ^ */
#define Font_ASC       1    // X  ASCII d
#define Font_STD       2    // XݼзǦrd
#define Font_SPC       3    // XݯSŸd
#define Font_SPCF      4    // XݯSrd

/* ReadFont24 Ǧ^ (ww) */
#define Font24_Asc     2
#define Font24_Chi     3

/* ReadFont16 Ǧ^ (ww) */
#define Font16_Asc     1
#define Font16_Chi     2


class CSFont
{
     FILE *Asc,*Std,*Spcf,*Spcs;
     FILE *Asc16,*Std16,*Spcf16,*Spcs16,*Stds16;

  public:
     unsigned char SysType;
     unsigned char PathConfig(char*);
     unsigned char OpenFont24(char*);
     unsigned char OpenFont16(char*);
     unsigned char FontInfo(unsigned char,unsigned char,long &);
     unsigned char ReadFont24(unsigned char*,unsigned char,unsigned char);
     unsigned char ReadFont16(unsigned char*,unsigned char,unsigned char);
     void CloseFont24(void);
     void CloseFont16(void);
     void PutFont24(int,int,unsigned char,char*,void (*)(unsigned int,unsigned int,unsigned char));
     void PutFont16(int,int,unsigned char,char*,void (*)(unsigned int,unsigned int,unsigned char));
     unsigned char Cbanner24(char*,unsigned char,char FILL='O');
     unsigned char Cbanner16(char*,unsigned char,char FILL='O');
     unsigned char AutoShowFont24(char*,char*);

};

#endif



/* Member Function in class CSFont */
/* z

 unsigned char PathConfig(char*);
 ǤJs]wɦW

 unsigned char OpenFont24(char*);
 unsigned char OpenFont16(char*);
 ǤJϥΤ]wɦW

 unsigned char FontInfo(unsigned char,unsigned char,long &);
 ǤJ Highbyte,Lowbyte,location;
 ǥXݤXdN ç location Ȭrrɤm

 unsigned char ReadFont24(unsigned char*,unsigned char,unsigned char);
 unsigned char ReadFont16(unsigned char*,unsigned char,unsigned char);
 ǤJrwİϫ,Highbyte,Lowbyte
 ǥXȬC@ Row Ҧ Byte 

 void CloseFont24(void);
 void CloseFont16(void);
 r

 void PutFont24(int,int,unsigned char,char*,void (*)(unsigned int,unsigned int,unsigned char));
 void PutFont16(int,int,unsigned char,char*,void (*)(unsigned int,unsigned int,unsigned char));
 ǤJ X,Y,color,r,øI Function

 unsigned char Cbanner24(char*,unsigned char,char FILL='O');
 unsigned char Cbanner16(char*,unsigned char,char FILL='O');
 ǤJr, 1-8 Ʀr , οܩʪr

 unsigned char AutoShowFont24(char*,char*);
 ǤJ r, ɦW

*/
